package app.insti.activity;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.media.Image;
import android.os.Bundle;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.StorageReference;
import com.squareup.picasso.Picasso;

import app.insti.R;
import app.insti.adapter.ActivitiesAdapter;
import app.insti.adapter.MyEventAdapter;
import app.insti.adapter.RecyclerViewAdapter;
import app.insti.api.model.MyEvent;

public class EventDescriptionActivity extends AppCompatActivity {

    private static final String TAG = "Clicked Event";
    private static MyEvent eventClicked = new MyEvent();
    private StorageReference storageReference;
    private DatabaseReference databaseReference;
    private String eventNameClicked;

    private TextView eventTitle;
    private ImageView eventImage;
    private TextView eventDate;
    private TextView eventDescription;
    private RecyclerView recyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_event_description);
//        Toast.makeText(getApplicationContext(),getIntent().getStringExtra("eventNameClicked"), Toast.LENGTH_SHORT).show();
        eventNameClicked = getIntent().getStringExtra("eventNameClicked");
//        initRecyclerView();
        fetchEventDescription();
//        displayEventDescription();

    }

//    private void initRecyclerView() {
//            LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
//            recyclerView.setLayoutManager(linearLayoutManager);
////            myEventAdapter = new MyEventAdapter();
////            recyclerView.setAdapter(myEventAdapter);
//
//            setSupportActionBar(findViewById(R.id.toolbar));
//            setTitle("Clicked Event");
//    }

    private void displayEventDescription() {
        System.out.println("************************************************");
        System.out.println(eventClicked.getMyEventName());
        System.out.println(eventClicked.getMyEventDescription());
        System.out.println(eventClicked.getAvatarUrl());
        System.out.println(eventClicked.getMyEventGoingCount());
        System.out.println(eventClicked.getMyEventInterestedCount());
        System.out.println(eventClicked.getMyEventStartTime());
        System.out.println(eventClicked.getMyEventEndTime());
        System.out.println(eventClicked.getMyEventVenues());
        System.out.println("************************************************");
    }

    private void updateEventDetails(){
        eventTitle = findViewById(R.id.event_page_title);
        eventImage = findViewById(R.id.event_picture_2);
        eventDate = findViewById(R.id.event_page_date);
        eventDescription = findViewById(R.id.event_page_description);
        eventTitle.setText(eventClicked.getMyEventName());
        eventDate.setText(eventClicked.getMyEventStartTime());
        eventDescription.setText(eventClicked.getMyEventDescription());
        Picasso.get().load(eventClicked.getAvatarUrl()).fit().centerCrop().into(eventImage);

    }


    private void fetchEventDescription() {
        databaseReference = FirebaseDatabase.getInstance().getReference("my_events");
        databaseReference.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                // This method is called once with the initial value and again
                // whenever data at this location is updated.
                for(DataSnapshot activitySnapshot : dataSnapshot.getChildren()){
                    MyEvent myEvent = activitySnapshot.getValue(MyEvent.class);
                    String myEventID = myEvent.getMyEventID();
                    if(myEventID.equals(eventNameClicked)){
                        eventClicked = myEvent;
//                        displayEventDescription();
                        updateEventDetails();
                        break;
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError error) {
                // Failed to read value
                Log.w(TAG, "Failed to read value.", error.toException());
            }
        });
    }
}
