package app.insti.api.model;

import androidx.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Objects;

import app.insti.interfaces.CardInterface;

public class MyEvent implements CardInterface {

    @NonNull()
    @SerializedName("id")
    private String myEventID;

    @SerializedName("str_id")
    private String myEventStrID;

    @SerializedName("name")
    private String myEventName;

    @SerializedName("description")
    private String myEventDescription;

    @SerializedName("image_url")
    private String myEventImageURL;

//    @SerializedName("start_time")
//    private Timestamp myEventStartTime;
//
//    @SerializedName("end_time")
//    private Timestamp myEventEndTime;

    @SerializedName("start_time")
    private String myEventStartTime;

    @SerializedName("end_time")
    private String myEventEndTime;

    @SerializedName("all_day")
    private boolean allDayMyEvent;

    @SerializedName("venue")
    private String myEventVenues;

    @SerializedName("parent")
    private String myEventParent;

    @SerializedName("interested_count")
    private int myEventInterestedCount;

    @SerializedName("going_count")
    private int myEventGoingCount;

    @SerializedName("interested")
    private List<User> myEventInterested;

    @SerializedName("going")
    private List<User> myEventGoing;

    public MyEvent() {

    }

    public MyEvent(String name, String venue, String date, String time, String description, int going, int interested, String parent, String id){
        this.myEventName = name;
        this.myEventVenues = venue;
        this.myEventStartTime = date;
        this.myEventEndTime = time;
        this.myEventDescription = description;
        this.myEventID = id;
        this.myEventGoingCount = going;
        this.myEventInterestedCount = interested;
        this.myEventParent = parent;
//        this.myEventImageURL = url;
    }

    @NonNull
    public String getMyEventID() {
        return myEventID;
    }

    public String getMyEventStrID() {
        return myEventStrID;
    }

    public String getMyEventName() {
        return myEventName;
    }

    public String getMyEventDescription() {
        return myEventDescription;
    }

    public String getMyEventImageURL() {
        return myEventImageURL;
    }

//    public Timestamp getMyEventStartTime() {
//        return myEventStartTime;
//    }
//
//    public Timestamp getMyEventEndTime() {
//        return myEventEndTime;
//    }

    public String getMyEventStartTime() {
        return myEventStartTime;
    }

    public String getMyEventEndTime() {
        return myEventEndTime;
    }

    public boolean isAllDayMyEvent() {
        return allDayMyEvent;
    }

    public String getMyEventVenues() {
        return myEventVenues;
    }

    public String getMyEventParent() {
        return myEventParent;
    }

    public int getMyEventInterestedCount() {
        return myEventInterestedCount;
    }

    public int getMyEventGoingCount() {
        return myEventGoingCount;
    }

    public List<User> getMyEventInterested() {
        return myEventInterested;
    }

    public List<User> getMyEventGoing() {
        return myEventGoing;
    }


    public void setMyEventID(@NonNull String myEventID) {
        this.myEventID = myEventID;
    }

    public void setMyEventStrID(String myEventStrID) {
        this.myEventStrID = myEventStrID;
    }

    public void setMyEventName(String myEventName) {
        this.myEventName = myEventName;
    }

    public void setMyEventDescription(String myEventDescription) {
        this.myEventDescription = myEventDescription;
    }

    public void setMyEventImageURL(String myEventImageURL) {
        this.myEventImageURL = myEventImageURL;
    }

//    public void setMyEventStartTime(Timestamp myEventStartTime) {
//        this.myEventStartTime = myEventStartTime;
//    }
//
//    public void setMyEventEndTime(Timestamp myEventEndTime) {
//        this.myEventEndTime = myEventEndTime;
//    }

    public void setMyEventStartTime(String myEventStartTime) {
        this.myEventStartTime = myEventStartTime;
    }

    public void setMyEventEndTime(String myEventEndTime) {
        this.myEventEndTime = myEventEndTime;
    }

    public void setAllDayMyEvent(boolean allDayMyEvent) {
        this.allDayMyEvent = allDayMyEvent;
    }


    public void setMyEventVenues(String myEventVenues) {
        this.myEventVenues = myEventVenues;
    }

    public void setMyEventParent(String myEventParent) {
        this.myEventParent = myEventParent;
    }

    public void setMyEventInterestedCount(int myEventInterestedCount) {
        this.myEventInterestedCount = myEventInterestedCount;
    }

    public void setMyEventGoingCount(int myEventGoingCount) {
        this.myEventGoingCount = myEventGoingCount;
    }

    public void setMyEventInterested(List<User> myEventInterested) {
        this.myEventInterested = myEventInterested;
    }

    public void setMyEventGoing(List<User> myEventGoing) {
        this.myEventGoing = myEventGoing;
    }


    @Override
    public long getId() {
        return getMyEventID().hashCode();
    }

    @Override
    public String getTitle() {
        return getMyEventName();
    }

    @Override
    public String getSubtitle() {
        return getMyEventDescription();
    }

    @Override
    public String getAvatarUrl() {
        return getMyEventImageURL();
    }
}

